=== hl/tools/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF5_HL_TOOLS C)

add_subdirectory (gif2h5)

add_subdirectory (h5watch)
