=== java/examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDFJAVA_EXAMPLES Java)

add_subdirectory (datasets)
add_subdirectory (datatypes)
add_subdirectory (groups)
add_subdirectory (intro)
