=== debian/changelog ===
hdf5 (1.10.7+repack-4) unstable; urgency=medium

  * libhdf5*-dev: Depends: libssl-dev
    This is a consequence of enabling read-only S3 virtual file driver

 -- Gilles Filippini <pini@debian.org>  Wed, 13 Oct 2021 00:46:20 +0200

hdf5 (1.10.7+repack-3) unstable; urgency=medium

  * libhdf5*-dev: Depends: libcurl4-openssl-dev | libcurl-dev (Closes:
    #995594). This is a consequence of enabling read-only S3 virtual file
    driver.
  * Fix 103-1 package name in shlibs files

 -- Gilles Filippini <pini@debian.org>  Sun, 03 Oct 2021 12:28:05 +0200

hdf5 (1.10.7+repack-2) unstable; urgency=medium

  * Enable again support for read-only S3 virtual file driver
    (Closes: #972537)

 -- Gilles Filippini <pini@debian.org>  Thu, 30 Sep 2021 23:34:48 +0200

hdf5 (1.10.7+repack-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Update symbols files

 -- Gilles Filippini <pini@debian.org>  Thu, 09 Sep 2021 20:22:14 +0200

hdf5 (1.10.6+repack-5) unstable; urgency=medium

  [ Andreas Beckmann ]
  * libhdf5-mpich-dev: bump libmpich-dev dependency to (>= 3.3-3~) (Closes:
    #992068)

 -- Gilles Filippini <pini@debian.org>  Wed, 11 Aug 2021 16:33:03 +0200
